# -*- coding: latin-1 -*-
#    QUENLIG: Questionnaire en ligne (Online interactive tutorial)
#    Copyright (C) 2008 Thierry EXCOFFIER, Olivier GLCK, Universite de Lyon
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
#

from questions import *
from check import *

add(name="informations",
    required=["intro:avantages", "intro:inconvnients"],
    question = "Rflexions sur le modle d'information&nbsp;: Que voulez-vous stocker avec quels objets&nbsp;? Pourquoi&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )


add(name="DIT",
    required=["informations"],
    question = "Rflexions sur l'organisation du DIT : Quelle architecture&nbsp;? Combien de niveaux&nbsp;? Pourquoi&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="DN",
    required=["informations"],
    question = "Caractristique du DN d'une entre&nbsp;?",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="DN racine",
    required=["DN"],
    question = "DN racine&nbsp;? Pourquoi ce choix&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="le DIT",
    required=["DIT"],
    question = "Schma du DIT avec DN&nbsp;:",
    nr_lines = 15,
    tests = (good_if_contains(''),),
    )

for i in range(5):
    add(name="DIT entre %d" % i,
        required=["le DIT"],
        question = "Donnez les informations sur une sorte d'entre (ou ne rpondez pas si vous avez dj expliqu toutes les sortes d'entre).",
        nr_lines = 5,
        default_answer = """DN de l'entre :
C'est un conteneur ou une feuille :
Objet structurel :
Autres objets :
Schma(s) Ncessaire(s) :""",
        tests = (good_if_contains(''),),
        )


add(name="schma",
        required=["le DIT"],
        question = "Comment voir dans quel schma un objet est stock&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="pre-installation",
        required=["le DIT"],
        question = "Quelles informations avez-vous donnes lors de la pr-installation (installation du <em>package</em>)&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="configuration",
        required=["pre-installation"],
        question = "Quelles modifications avez-vous faites dans le fichier de configuration du serveur&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="redmarrer",
        required=["pre-installation"],
        question = "Comment redmarrer le serveur&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="quand",
        required=["redmarrer"],
        question = "Quand est-il ncessaire de redmarrer le serveur&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="log",
        required=["pre-installation"],
        question = "O se trouvent les logs du serveur&nbsp;?",
        tests = (good_if_contains(''),),
        )


add(name="gq",
        required=["log"],
        question = "Donnez les paramtres de connexion avec <tt>gq</tt>&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )


add(name="contenu",
        required=["gq"],
        question = "Quelles sont les entres dans l'annuaire&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="ldif",
        required=["gq"],
        question = """Format LDIF d'une entre de chacun des types.
    <p>
    Vous aurez 0 points si vous dpassez 50 lignes dans la rponse.
        """,
        nr_lines = 50,
        tests = (good_if_contains(''),),
        )

add(name="ldapadd",
        required=["ldif"],
        question = "Commande <tt>ldapadd</tt>&nbsp;:",
        tests = (good_if_contains(''),),
        )

add(name="tester",
        required=["ldapadd"],
        question = "Mthode pour vrifier que les entres ont effectivement t ajoutes&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="ajout binome",
        required=["tester"],
        question = "Ajout des binmes et d'un groupe avec l'utilitaire <tt>gq</tt>. Comment procdez-vous&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="ajout machines",
        required=["tester"],
        question = "Indiquez le nom de votre zone DNS, le nom canonique de votre machine et donnez le programme ou script qui gnre un fichier LDIF dcrivant toutes les machines de votre zone DNS&nbsp;:",
        nr_lines = 15,
        tests = (good_if_contains(''),),
        )


add(name="filtre",
        required=["tester"],
        question = "Mthodes pour voir tout le contenu de l'annuaire. Indiquez pour chacune d'elles comment faire ainsi que le filtre utilis&nbsp;:",
        nr_lines = 15,
        tests = (good_if_contains(''),),
        )

add(name="filtre rdn",
        required=["filtre"],
        question = "URL pour afficher <b>uniquement</b> les <tt>rdn</tt> de l'annuaire&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="filtre membres",
        required=["filtre"],
        question = "URL pour afficher <b>uniquement</b> les membres (nom, uid) du groupe contenant l'ensemble des binmes de la salle&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="filtre utilisateurs",
        required=["filtre"],
        question = "URL pour afficher <b>uniquement</b> la liste des utilisateurs (nom, uid) qui n'appartiennent pas  l'ensemble des binmes de la salle&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="filtre machine",
        required=["filtre"],
        question = "URL pour afficher <b>uniquement</b> la liste des machines rpertories dans l'annuaire avec son/ses nom(s) et son adresse IP&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="mot de passe",
        required=["ajout binome"],
        question = "Donnez la commande <tt>ldapsearch</tt> pour afficher <tt>uid</tt> et mot de passe de chaque utilisateur&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="mot de passe admin",
        required=["mot de passe"],
        question = "Qu'affiche la commande <tt>ldapsearch</tt> pour afficher <tt>uid</tt> et mot de passe si elle est excute en tant qu'administrateur&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="mot de passe b1",
        required=["mot de passe"],
        question = "Qu'affiche la commande <tt>ldapsearch</tt> pour afficher <tt>uid</tt> et mot de passe si elle est excute en tant que l'utilisateur <tt>b1</tt>&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )


add(name="mot de passe ?",
        required=["mot de passe admin", "mot de passe b1"],
        question = "Affichage des mots de passe par un admin ou non, que constatez-vous ? Expliquez.",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="autorisation",
        required=["mot de passe"],
        question = """Modifications de <tt>slapd.conf</tt> pour que <tt>homeDirectory</tt> soit modifiable uniquement par l'administrateur, et lisible que par les utilisateurs authentifis.
            <p>
            Vous aurez 0 points si vous dpassez 50 lignes dans la rponse.
        """,
        nr_lines = 10,
        tests = (good_if_contains(''),),
        )

add(name="authentification",
        required=["mot de passe"],
        question = "Authentification via LDAP + changement de mot de passe. Quel(s) fichier(s) modifier et comment&nbsp;? Sur le client ou sur le serveur LDAP&nbsp;?",
        nr_lines = 20,
        tests = (good_if_contains(''),),
        )

add(name="vrification",
        required=["authentification"],
        question = "Contrle du bon fonctionnement avec les commandes id, su ou telnet, passwd, chown, chgrp, ... Expliquez et commentez les tests effectus&nbsp;:",
        nr_lines = 10,
        tests = (good_if_contains(''),),
        )


add(name="passwd",
        required=["vrification"],
        question = "Aprs avoir modifi le mot de passe avec la commande <tt>passwd</tt>, regardez le contenu de l'attribut <tt>userPassword</tt> avec <tt>ldapsearch</tt>&nbsp;! Commentaire&nbsp;:",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="hostname",
        required=["vrification"],
        question = "Rsolution de noms via l'annuaire LDAP. Que suffit-il de faire&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )

add(name="alias",
        required=["hostname"],
        question = "Comment ajoutez-vous un alias ? Le ping vers cet alias fonctionne t-il&nbsp;?",
        nr_lines = 5,
        tests = (good_if_contains(''),),
        )


add(name="wireshark",
        required=["hostname"],
        question = "Visualisation d'changes entre le client et le serveur LDAP. Quel filtre de capture utilisez-vous&nbsp;?",
        tests = (good_if_contains(''),),
        )

add(name="id",
        required=["wireshark"],
        question = "Echanges LDAP observs entre le client et le serveur (nombre de messages, lisibilit des donnes vhiculant dans les requtes/rponses, ...) suite  <tt>id b1</tt>&nbsp;?",
        nr_lines = 20,
        tests = (good_if_contains(''),),
        )

add(name="nouveau",
        required=["id"],
        question = "Intgration d'un nouvel utilisateur et de sa machine dans votre rseau, donnez le nom de la machine, le nom de login et la liste des oprations  effectuer&nbsp;:",
        nr_lines = 20,
        tests = (good_if_contains(''),),
        )

add(name="total",
        required=["nouveau"],
        question = "Configurez une machine qui soit  la fois client NFS, client NIS, client LDAP et client DNS. Comment testez-vous que tout fonctionne correctement&nbsp;?",
        nr_lines = 20,
        tests = (good_if_contains(''),),
        )














































