# -*- coding: latin-1 -*-
#    QUENLIG: Questionnaire en ligne (Online interactive tutorial)
#    Copyright (C) 2008 Thierry EXCOFFIER, Olivier GLCK, Universite de Lyon
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
#

from questions import *
from check import *

add(name="exportfs",
    required=["intro:avantages", "intro:inconvnients"],
    question = "Que fait la commande <tt>exportfs rv</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

# Mise en place

add(name="installation",
    required=["exportfs"],
    question = "Comment faites-vous pour mettre en place le serveur NFS",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="dmarrage",
    required=["installation"],
    question = "Comment dmarrez-vous le serveur NFS",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="export",
    required=["dmarrage"],
    question = "Le lancement du serveur NFS dclenche-t-il l'excution de la commande <tt>exportfs</tt>",
    tests = (good_if_contains(''),),
    )

add(name="log",
    required=["dmarrage"],
    question = "O se trouvent les logs du serveur NFS&nbsp;?",
    tests = (good_if_contains(''),),
    )

add(name="interdire",
    required=["log"],
    question = "Comment faites-vous pour interdire l'accs NFS aux stations <tt>.130</tt> et <tt>.131</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )


add(name="rpc",
    required=["dmarrage"],
    question = "Quelle commande permet de vrifier quels sont les services RPC disponibles sur votre serveur",
    tests = (good_if_contains(''),),
    )

add(name="nfs",
    required=["dmarrage"],
    question = "Quelle commande permet de vrifier que le service NFS est bien prsent sur votre serveur",
    tests = (good_if_contains(''),),
    )

add(name="partitions",
    required=["dmarrage"],
    question = "Quelle commande permet de connatre l'ensemble des partitions NFS actuellement exportes par votre serveur",
    tests = (good_if_contains(''),),
    )


add(name="client",
    required=["rpc", "nfs", "partitions"],
    question = "Comment configurez-vous le client pour qu'il utilise la partition du serveur",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="erreurs",
    required=["client"],
    question = "Plusieurs scnarii permettant de tester toute la configuration avec vrifications exhaustives des droits d'accs et messages d'erreurs NFS rencontrs avec explications&nbsp;:",
    nr_lines = 20,
    tests = (good_if_contains(''),),
    )

add(name="auto",
    required=["client"],
    question = "Que signifie l'option de montage <tt>auto</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="mount",
    required=["client"],
    question = "Que fait la commande : <tt>mount -a -t nfs</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="root_lit",
    required=["client"],
    question = "Sur le client, en tant qu'utilisateur <tt>root</tt>, quels fichiers de <tt>/tmp/etc</tt> sont lisibles",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="moi_lit",
    required=["client"],
    question = "Sur le client, en tant qu'utilisateur <tt>moi</tt>, quels fichiers de <tt>/tmp/etc</tt> sont lisibles",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="lecture",
    required=["root_lit", "moi_lit"],
    question = "Expliquez les diffrences d'accs en lecture pour <tt>root</tt> et </tt>moi</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="superroot",
    required=["lecture"],
    question = "Comment modifier la configuration du serveur pour lire tous les fichiers en tant que <tt>root</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

# Protocole

add(name="protocole",
    required=["client"],
    question = "Connexion en tant que <tt>toto</tt> depuis une machine cliente. Expliquez et commentez :",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="filtre",
    required=["protocole"],
    question = "Visualisation des changes entre le client et le serveur NFS. Quel filtre de capture utilisez vous ?",
    tests = (good_if_contains(''),),
    )

r = """Rsum (nombre de messages, noms et paramtres des procdures distantes excutes, ...) et commentaires des changes NFS suite  la commande : """


add(name="mkdir",
    required=["protocole"],
    question = r + "<tt>mkdir /nfshome/toto/TMP</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="chmod",
    required=["protocole"],
    question = r + "<tt>chmod 777 /nfshome/toto/TMP</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="cd",
    required=["protocole"],
    question = r + "<tt>cd /nfshome/toto/TMP</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="criture",
    required=["protocole"],
    question = r + "<tt>echo \"Bonjour\" &gt;bj.txt</tt>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )


# S'il reste du temps

add(name="new",
    required=["filtre", "mkdir", "chmod", "cd", "criture"],
    question = "Intgration d'un nouvel utilisateur et de sa machine dans votre rseau",
    nr_lines = 5,
    default_answer = """Nom de machine :
Nom de login :
Oprations  effectuer : 
""",
    tests = (good_if_contains(''),),
    )


add(name="final",
    required=["new"],
    question = "Configurez une machine qui soit  la fois client NFS, client NIS, client LDAP et client DNS.<b>Comment testez-vous que tout fonctionne correctement ?</b>",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )











