# -*- coding: latin-1 -*-
#    QUENLIG: Questionnaire en ligne (Online interactive tutorial)
#    Copyright (C) 2008 Thierry EXCOFFIER, Olivier GLCK, Universite de Lyon
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    Contact: Thierry.EXCOFFIER@bat710.univ-lyon1.fr
#

from questions import *
from check import *

add(name="domaine",
    required=["intro:avantages", "intro:inconvnients"],
    question = "Quel est votre nom de domaine NIS&nbsp;?",
    tests = (good_if_contains(''),),
    )

# 4.1

add(name="dmons",
    required=["domaine"],
    question = "Quels dmons doivent tourner sur le serveur NIS matre&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="vrifier",
    required=["domaine"],
    question = "Comment faites-vous sur le client pour positionner/vrifier le nom de votre domaine NIS&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="NISSERVER",
    required=["domaine"],
    question = "Comment faites-vous pour renseigner la variable NISSERVER&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="broadcast",
    required=["domaine"],
    question = "Comment faites-vous pour que le client NIS ne fasse pas de <em>broadcast</em>&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="ypinit",
    required=["domaine"],
    question = "Indiquez la ligne de commande que vous tapez pour crer la base NIS&nbsp;?",
    tests = (good_if_contains(''),),
    )

add(name="dmarrage",
    required=["domaine", "ypinit"],
    question = "Une fois que le serveur NIS est dmarr, comment faites-vous pour vrifier que les bons dmons sont lancs&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )


add(name="ypinit2",
    required=["ypinit"],
    question = "Que fait prcisment la commande <tt>ypinit</tt>&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="carte",
    required=["ypinit"],
    question = "Qu'est ce qu'une carte (<em>map</em>)&nbsp;? Les cartes sont-elles lisibles par la commande <tt>cat</tt>&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="ypmake",
    required=["ypinit"],
    question = "Que fait la commande <tt>make</tt> dans <tt>/var/yp</tt>&nbsp;?",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

# 4.2


add(name="client",
    required=["dmarrage"],
    question = "Configurez un client NIS sur une autre machine. Manipulations effectues&nbsp;",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="rpc",
    required=["client"],
    question = "Quelle commande permet de vrifier quels sont les services RPC disponibles sur votre serveur&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="service",
    required=["client"],
    question = "Quelle commande permet de vrifier qu'un serveur NIS est bien joignable sur votre serveur&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="password",
    required=["client"],
    question = "Quelle commande permet de vrifier que le service permettant le changement de mot de passe via les NIS est disponible&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="bind",
    required=["client"],
    question = "Quelle commande permet de savoir si un client NIS tourne sur une machine&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="serveur",
    required=["client"],
    question = "Quelle commande permet de connatre,  partir d'une machine cliente, le serveur NIS auquel elle est associe&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

add(name="affiche carte",
    required=["client"],
    question = "Quelle commande permet d'afficher,  partir d'une machine cliente, le contenu de la carte <tt>passwd</tt> du serveur NIS&nbsp;?<p>Indiquez sur quelle machine vous faites tourner la commande.",
    nr_lines = 2,
    tests = (good_if_contains(''),),
    )

#

add(name="carte des noms",
    required=["affiche carte"],
    question = "Scnarii de tests. Indiquez ce que vous faites sur le client et sur le serveur pour chacun d'eux.<p>Carte des noms de machine :",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="carte passwd",
    required=["affiche carte"],
    question = "Scnarii de tests. Indiquez ce que vous faites sur le client et sur le serveur pour chacun d'eux.<p>Cartes passwd/group :",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

# 4.3

add(name="utilisateur",
    required=["affiche carte"],
    question = """
Sur le serveur NIS, ajoutez un utilisateur <tt>titi</tt> et donnez un nom
 votre machine cliente (<tt>nisclient_xxxx</tt> o <tt>xxxx</tt> sont
les initiales du binme).
<p>
Indiquez ce qu'il faut faire pour
ajouter l'utilisateur et la machine et que ces informations
soient accessibles depuis le client NIS.""",
    nr_lines = 5,
    tests = (good_if_contains(''),),
    )

add(name="filtre",
    required=["affiche carte"],
    question = "Echanges entre le client et le serveur NIS. Quel filtre de capture utilisez vous&nbsp;?",
    tests = (good_if_contains(''),),
    )

add(name="ypwhich",
    required=["filtre"],
    question = "Rsum des changes observs (nombre de messages, noms et paramtres des procdures distantes excutes, ...) suite  la commande <tt>ypwhich</tt>",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )


add(name="telnet",
    required=["filtre"],
    question = "Rsum des changes observs (nombre de messages, noms et paramtres des procdures distantes excutes, ...) suite  la commande <tt>telnet nisclient_xxxx</tt>",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

add(name="id",
    required=["filtre"],
    question = "Rsum des changes observs (nombre de messages, noms et paramtres des procdures distantes excutes, ...) suite  la commande <tt>id titi</tt>",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

add(name="yppasswd",
    required=["filtre"],
    question = "Rsum des changes observs (nombre de messages, noms et paramtres des procdures distantes excutes, ...) suite  la commande <tt>yppasswd titi</tt>",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

# 4.4

add(name="access",
    required=["yppasswd", "telnet", "ypwhich", "id"],
    question = "Restreindre l'accs uniquement  l'ensemble des machines de votre salle ayant une adresse IP suprieure  .128, exceptes les stations .132 et .133. Comment procdez vous&nbsp;?",
    tests = (good_if_contains(''),),
    nr_lines = 10,
    )

add(name="permanent nomade",
    required=["access"],
    question = "Deux catgories : personnels permanents et personnels nomades. Solution&nbsp;?",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

add(name="tests",
    required=["permanent nomade", "access"],
    question = "Tests des deux configurations prcdentes de restriction d'accs (voir bas de cette page) :",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

# 4.5

add(name="nouvelle machine",
    required=["tests"],
    question = "Intgration d'un nouvel utilisateur et de sa machine dans votre rseau, indiquez le nom de sa machine, son login et la liste des oprations  effectuer.",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

add(name="totale",
    required=["nouvelle machine"],
    question = "Configurez une machine qui soit  la fois client NFS, client NIS, client LDAP et client DNS. Comment testez-vous que tout fonctionne correctement&nbsp;?",
    tests = (good_if_contains(''),),
    nr_lines = 5,
    )

add(name="secondaire",
    required=["nouvelle machine"],
    question = "Mise en place d'un serveur NIS secondaire, configuration d'un client NIS recherchant le serveur NIS par broadcast et vrification que si le serveur NIS associ au client tombe en panne, l'autre serveur prend le relais pour rpondre au client. Expliquez comment mettre en place et tester tout cela.",
    tests = (good_if_contains(''),),
    nr_lines = 10,
    )

add(name="restrictions",
    required=["tests"],
    question = "Expliquez comment configurer des accs restreints carte par carte (<tt>man ypserv.conf</tt>).",
    tests = (good_if_contains(''),),
    nr_lines = 10,
    )
















